--- WARNING: THIS IS AN AUTO-GENERATED FILE, DO NOT EDIT. PLEASE MODIFY THE ORIGINAL SOURCE IN THE https://github.com/istio/istio REPO source_repo: https://github.com/istio/istio title: pilot-agent description: Istio Pilot agent. generator: pkg-collateral-docs number_of_entries: 5 ---

Istio Pilot agent runs in the sidecar or gateway container and bootstraps Envoy.

Flags | Description
--- | ---
`--log_as_json` | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` | Comma-separated list of scopes for which to include caller information, scopes can be any of [all, default, model, rbac] (default ``)
`--log_output_level <string>` | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [all, default, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [all, default, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)

## pilot-agent proxy

Envoy proxy agent

    pilot-agent proxy [flags]

Flags | Description
--- | ---
`--applicationPorts <stringSlice>` | Ports exposed by the application. Used to determine that Envoy is configured and ready to receive traffic. (default `[]`)
`--binaryPath <string>` | Path to the proxy binary (default `/usr/local/bin/envoy`)
`--concurrency <int>` | number of worker threads to run (default `0`)
`--configPath <string>` | Path to the generated configuration file directory (default `/etc/istio/proxy`)
`--connectTimeout <duration>` | Connection timeout used by Envoy for supporting services (default `1s`)
`--controlPlaneAuthPolicy <string>` | Control Plane Authentication Policy (default `NONE`)
`--controlPlaneBootstrap` | Process bootstrap provided via templateFile to be used by control plane components.
`--customConfigFile <string>` | Path to the custom configuration file (default ``)
`--datadogAgentAddress <string>` | Address of the Datadog Agent (default ``)
`--disableInternalTelemetry` | Disable internal telemetry
`--discoveryAddress <string>` | Address of the discovery service exposing xDS (e.g. istio-pilot:8080) (default `istio-pilot:15010`)
`--dnsRefreshRate <string>` | The dns_refresh_rate for bootstrap STRICT_DNS clusters (default `300s`)
`--domain <string>` | DNS domain suffix. If not provided uses ${POD_NAMESPACE}.svc.cluster.local (default ``)
`--drainDuration <duration>` | The time in seconds that Envoy will drain connections during a hot restart (default `45s`)
`--envoyAccessLogServiceAddress <string>` | Host and Port of an Envoy gRPC Access Log Service API implementation (e.g. accesslog-service.istio-system:15000) (default ``)
`--envoyMetricsServiceAddress <string>` | Host and Port of an Envoy Metrics Service API implementation (e.g. metrics-service:15000) (default ``)
`--id <string>` | Proxy unique ID. If not provided uses ${POD_NAME}.${POD_NAMESPACE} from environment variables (default ``)
`--ip <string>` | Proxy IP address. If not provided uses ${INSTANCE_IP} environment variable. (default ``)
`--lightstepAccessToken <string>` | Access Token for LightStep Satellite pool (default ``)
`--lightstepAddress <string>` | Address of the LightStep Satellite pool (default ``)
`--lightstepCacertPath <string>` | Path to the trusted cacert used to authenticate the pool (default ``)
`--lightstepSecure` | Should connection to the LightStep Satellite pool be secure
`--log_as_json` | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` | Comma-separated list of scopes for which to include caller information, scopes can be any of [all, default, model, rbac] (default ``)
`--log_output_level <string>` | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [all, default, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [all, default, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--mixerIdentity <string>` | The identity used as the suffix for mixer's spiffe SAN. This would only be used by pilot all other proxy would get this value from pilot (default ``)
`--parentShutdownDuration <duration>` | The time in seconds that Envoy will wait before shutting down the parent process during a hot restart (default `1m0s`)
`--pilotIdentity <string>` | The identity used as the suffix for pilot's spiffe SAN (default ``)
`--proxyAdminPort <uint16>` | Port on which Envoy should listen for administrative commands (default `15000`)
`--proxyComponentLogLevel <string>` | The component log level used to start the Envoy proxy (default `misc:error`)
`--proxyLogLevel <string>` | The log level used to start the Envoy proxy (choose from {trace, debug, info, warning, error, critical, off}) (default `warning`)
`--serviceCluster <string>` | Service cluster (default `istio-proxy`)
`--serviceregistry <string>` | Select the platform for service registry, options are {Kubernetes, Consul, Mock} (default `Kubernetes`)
`--statsdUdpAddress <string>` | IP Address and Port of a statsd UDP listener (e.g. 10.75.241.127:9125) (default ``)
`--statusPort <uint16>` | HTTP Port on which to serve pilot agent status. If zero, agent status will not be provided. (default `0`)
`--templateFile <string>` | Go template bootstrap config (default ``)
`--trust-domain <string>` | The domain to use for identities (default ``)
`--zipkinAddress <string>` | Address of the Zipkin service (e.g. zipkin:9411) (default ``)

## pilot-agent request

Makes an HTTP request to the Envoy admin API

    pilot-agent request <method> <path> [<body>] [flags]

Flags | Description
--- | ---
`--log_as_json` | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` | Comma-separated list of scopes for which to include caller information, scopes can be any of [all, default, model, rbac] (default ``)
`--log_output_level <string>` | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [all, default, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [all, default, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)

## pilot-agent version

Prints out build version information

    pilot-agent version [flags]

Flags | Shorthand | Description
--- | --- | ---
`--log_as_json` |  | Whether to format output as JSON or in plain console-friendly format
`--log_caller <string>` |  | Comma-separated list of scopes for which to include caller information, scopes can be any of [all, default, model, rbac] (default ``)
`--log_output_level <string>` |  | Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [all, default, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info`)
`--log_rotate <string>` |  | The path for the optional rotating log file (default ``)
`--log_rotate_max_age <int>` |  | The maximum age in days of a log file beyond which the file is rotated (0 indicates no limit) (default `30`)
`--log_rotate_max_backups <int>` |  | The maximum number of log file backups to keep before older files are deleted (0 indicates no limit) (default `1000`)
`--log_rotate_max_size <int>` |  | The maximum size in megabytes of a log file beyond which the file is rotated (default `104857600`)
`--log_stacktrace_level <string>` |  | Comma-separated minimum per-scope logging level at which stack traces are captured, in the form of <scope>:<level>,<scope:level>,... where scope can be one of [all, default, model, rbac] and level can be one of [debug, info, warn, error, fatal, none] (default `default:none`)
`--log_target <stringArray>` |  | The set of paths where to output the log. This can be any path as well as the special values stdout and stderr (default `[stdout]`)
`--output <string>` | `-o` | One of 'yaml' or 'json'. (default ``)
`--short` | `-s` | Use --short=false to generate full version information

## Environment variables

These environment variables affect the behavior of the `pilot-agent` command.

Variable Name | Type | Default Value | Description
--- | --- | --- | ---
`INSTANCE_IP` | String | `` |
`ISTIO_BOOTSTRAP` | String | `` |
`ISTIO_BOOTSTRAP_OVERRIDE` | String | `` |
`ISTIO_GPRC_MAXSTREAMS` | Integer | `100000` | Sets the maximum number of concurrent grpc streams.
`ISTIO_KUBE_APP_PROBERS` | String | `` |
`ISTIO_META_TLS_CLIENT_CERT_CHAIN` | String | `/etc/certs/cert-chain.pem` |
`ISTIO_META_TLS_CLIENT_KEY` | String | `/etc/certs/key.pem` |
`ISTIO_META_TLS_CLIENT_ROOT_CERT` | String | `/etc/certs/root-cert.pem` |
`ISTIO_META_TLS_SERVER_CERT_CHAIN` | String | `/etc/certs/cert-chain.pem` |
`ISTIO_META_TLS_SERVER_KEY` | String | `/etc/certs/key.pem` |
`ISTIO_META_TLS_SERVER_ROOT_CERT` | String | `/etc/certs/root-cert.pem` |
`ISTIO_NAMESPACE` | String | `` |
`PILOT_CERT_DIR` | String | `` |
`PILOT_DEBOUNCE_AFTER` | Time Duration | `100ms` | The delay added to config/registry events for debouncing. This will delay the push by at least this internal. If no change is detected within this period, the push will happen, otherwise we'll keep delaying until things settle, up to a max of PILOT_DEBOUNCE_MAX.
`PILOT_DEBOUNCE_MAX` | Time Duration | `10s` | The maximum amount of time to wait for events while debouncing. If events keep showing up with no breaks for this time, we'll trigger a push.
`PILOT_DEBUG_ADSZ_CONFIG` | Boolean | `false` |
`PILOT_DISABLE_XDS_MARSHALING_TO_ANY` | Boolean | `false` |
`PILOT_ENABLE_FALLTHROUGH_ROUTE` | Boolean | `true` | EnableFallthroughRoute provides an option to add a final wildcard match for routes. When ALLOW_ANY traffic policy is used, a Passthrough cluster is used. When REGISTRY_ONLY traffic policy is used, a 502 error is returned.
`PILOT_ENABLE_MYSQL_FILTER` | Boolean | `false` | EnableMysqlFilter enables injection of `envoy.filters.network.mysql_proxy` in the filter chain.
`PILOT_ENABLE_REDIS_FILTER` | Boolean | `false` | EnableRedisFilter enables injection of `envoy.filters.network.redis_proxy` in the filter chain.
`PILOT_HTTP10` | Boolean | `false` | Enables the use of HTTP 1.0 in the outbound HTTP listeners, to support legacy applications.
`PILOT_INITIAL_FETCH_TIMEOUT` | Time Duration | `0s` | Specifies the initial_fetch_timeout for config. If this time is reached without a response to the config requested by Envoy, the Envoy will move on with the init phase. This prevents envoy from getting stuck waiting on config during startup.
`PILOT_PUSH_THROTTLE` | Integer | `100` | Limits the number of concurrent pushes allowed. On larger machines this can be increased for faster pushes
`PILOT_RESTRICT_POD_UP_TRAFFIC_LOOP` | Boolean | `true` | If enabled, this will block inbound traffic from matching outbound listeners, which could result in an infinite loop of traffic. This option is only provided for backward compatibility purposes and will be removed in the near future.
`PILOT_SCOPE_PUSHES` | Boolean | `true` | If enabled, pilot will attempt to limit unnecessary pushes by determining what proxies a config or endpoint update will impact.
`PILOT_SIDECAR_USE_REMOTE_ADDRESS` | Boolean | `false` | UseRemoteAddress sets useRemoteAddress to true for side car outbound listeners.
`PILOT_TRACE_SAMPLING` | Floating-Point | `100` | Sets the mesh-wide trace sampling percentage. Should be 0.0 - 100.0. Precision to 0.01. Default is 100, not recommended for production use.
`POD_NAME` | String | `` |
`POD_NAMESPACE` | String | `` |
`SDS_ENABLED` | Boolean | `false` |
`SDS_JWT_PATH` | String | `/var/run/secrets/tokens/istio-token` | path of token which is used for request key/cert through SDS
`SDS_UDS_PATH` | String | `/var/run/sds/uds_path` | SDS unix domain socket path
`TERMINATION_DRAIN_DURATION_SECONDS` | Integer | `5` | The amount of time allowed for connections to complete on pilot-agent shutdown. On receiving SIGTERM or SIGINT, pilot-agent tells the active Envoy to start draining, preventing any new connections and allowing existing connections to complete. It then sleeps for the TerminationDrainDuration and then kills any remaining active Envoy processes.
`USE_ISTIO_JWT_FILTER` | Boolean | `false` | Use the Istio JWT filter for JWT token verification.
`V2_REFRESH` | Time Duration | `0s` |

## Exported metrics

Metric Name | Type | Description
--- | --- | ---
`endpoint_no_pod` | `LastValue` | Endpoints without an associated pod.
`pilot_conflict_inbound_listener` | `LastValue` | Number of conflicting inbound listeners.
`pilot_conflict_outbound_listener_http_over_current_tcp` | `LastValue` | Number of conflicting wildcard http listeners with current wildcard tcp listener.
`pilot_conflict_outbound_listener_tcp_over_current_http` | `LastValue` | Number of conflicting wildcard tcp listeners with current wildcard http listener.
`pilot_conflict_outbound_listener_tcp_over_current_tcp` | `LastValue` | Number of conflicting tcp listeners with current tcp listener.
`pilot_destrule_subsets` | `LastValue` | Duplicate subsets across destination rules for same host
`pilot_discovery_calls` | `Sum` | Individual method calls in Pilot
`pilot_discovery_errors` | `Sum` | Errors encountered during a given method call within Pilot
`pilot_discovery_resources` | `Distribution` | Returned resource counts per method by Pilot
`pilot_duplicate_envoy_clusters` | `LastValue` | Duplicate envoy clusters caused by service entries with same hostname
`pilot_eds_no_instances` | `LastValue` | Number of clusters without instances.
`pilot_endpoint_not_ready` | `LastValue` | Endpoint found in unready state.
`pilot_jwks_resolver_network_fetch_fail_total` | `Sum` | Total number of failed network fetch by pilot jwks resolver
`pilot_jwks_resolver_network_fetch_success_total` | `Sum` | Total number of successfully network fetch by pilot jwks resolver
`pilot_no_ip` | `LastValue` | Pods not found in the endpoint table, possibly invalid.
`pilot_total_rejected_configs` | `Sum` | Total number of configs that Pilot had to reject or ignore.
`pilot_virt_services` | `LastValue` | Total virtual services known to pilot.
`pilot_vservice_dup_domain` | `LastValue` | Virtual services with dup domains.